<?php 
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {   # display source of script if requested so
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
# test script to display information retrieved by CURL VERSION 2 incl error and return codes
#
ini_set('display_errors', 'On'); 		// set all error checking on
error_reporting(E_ALL);

$length	= 1000;					// max length of data to be displayed outside iframne
#
#Array of URLs to test
#

$arrRead['metarXML'] 	= array('link' => 'http://aviationweather.gov/adds/dataserver_current/httpparam?dataSource=metars&requestType=retrieve&format=xml&hoursBeforeNow=3&mostRecent=true&stationString=EHRD',
			'txt'	=> 'conditions nearby airport - xml file, difference in output because iframe will not display xml tags, only the data');

$arrRead['metarOld'] 	= array('link' => 'http://weather.noaa.gov/pub/data/observations/metar/stations/EHRD.TXT',
			'txt'	=> 'conditions nearby airport - txt file, should be identical in iframe as in browser');
#
# Display all URLs in iframe and as retrieved by CURL on server.
#
foreach ($arrRead as $key => $arr) {
#
# first display iframe so that the link is executed in the visiors browser
#
	$link	= $arr['link'];
	echo '<hr /><p>The link below retrieves '.$arr['txt'].'<br /><small>'.$link.'</small><br /></p>

<iframe src="'.$link.'" style ="width:95%; height: 100px; padding: 10px;border: 5px black solid; background: transparent; vertical-align: bottom;">
iframe
</iframe>'.PHP_EOL;
#
# Now do a CURL to retrieve the same information
#
	echo '<p>The same link<br /><small>'.$link.'</small><br /> executed in your server returned:</p>';

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $link);
	curl_setopt ($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
	$rawData = curl_exec ($ch);

	echo '<p><b>Return</b> codes: <pre>';
	$info	= curl_getinfo($ch);
	print_r ($info);
	echo '</pre></p>'.PHP_EOL;
	
	$errors = curl_error($ch);
	curl_close ($ch);
	unset ($ch);
		
	echo '<p><b>Error</b> codes: '.$errors.'</p>'.PHP_EOL;
	if (strlen($rawData) < 2) { 
		echo '<p><b>No data</b> was retrieved for '.$link.'</p>'.PHP_EOL;
		continue;
	}	
	$from 	= array('<','>');
	$to	= array('&lt;','&gt;');
	$string = str_replace ($from, $to, $rawData);
	echo '<p><b>Data</b> returned (maximum first '.$length.' characters displayed)</p> <br /><pre>'.substr($string,0,$length).'</pre><br />'.PHP_EOL;
}
echo '<hr ><h3 style="color: red;">To check the code of this script, add <span style="color: black;">?sce=view</span>  to the url and the script will display itself</h3>';
